#!/usr/bin/perl
use strict;
use warnings;
use Math::MPFI qw(:mpfi);

Rmpfi_set_default_prec(16);

sub format_epsilon{
  my $x = $_[0];
  
  my $m = Math::MPFR->new();
  Rmpfi_mid($m, $x);
  
  my $y = Math::MPFI->new();
  Rmpfi_sub_fr($y, $x, $m);
  
  my $epsilon = Math::MPFR->new();
  Rmpfi_mag($epsilon, $y);
  
  return "$m +/- $epsilon";
}

my $R1 = 1200 + Math::MPFI->new('[-120,120]');
my $R2 = 800 + Math::MPFI->new('[-80,80]');
my $R = 1/(1/$R1+1/$R2);

print "R = $R = ", format_epsilon($R),"\n";
