#!/usr/bin/perl
use strict;
use warnings;
use Math::MPFI qw(:mpfi);

package Math::MPFI;

use overload '<=' => \&myinfeq,
             '>=' => \&mysupeq,
             '==' => \&myequiv;
             
sub Math::MPFI::myinfeq {
  my ($x, $y) = @_;
  Rmpfi_is_inside($x, $y);
}
   
sub Math::MPFI::mysupeq {
  my ($x, $y) = @_;
  Rmpfi_is_inside($y, $x);
}        

sub Math::MPFI::myequiv{
  my ($x, $y) = @_;
  Rmpfi_is_inside($x, $y) && Rmpfi_is_inside($y, $x);
}

package main;

my $x = Math::MPFI->new('[1,4]');
my $y = Math::MPFI->new('[2,3]');
my $z = Math::MPFI->new('[4,6]');

print "$x <= $y is ", $x <= $y ? 'true':'false', "\n";
print "$x >= $y is ", $x >= $y ? 'true':'false', "\n";
print "$y <= $z is ", $y <= $z ? 'true':'false', "\n";
print "$y >= $z is ", $y >= $z ? 'true':'false', "\n\n";

print "$x == $y is ", $x == $y ? 'true':'false', "\n";
print "$x == $x is ", $x == $x ? 'true':'false', "\n";
